<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Forecast Weather</title>
  <!-- jQuery -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
  <!-- popper.js -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/2.9.2/umd/popper.min.js"></script>
  <!-- Bootstrap 4 -->
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"></script>    
  <!-- Font-Awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css"/>
  <!-- AdminLTE App -->
  <script src="https://cdn.jsdelivr.net/npm/admin-lte@3.1/dist/js/adminlte.min.js"></script>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/admin-lte@3.1/dist/css/adminlte.min.css">
</head>
<style>
  body {
    font-family: Georgia, serif;
  }
  .bg-blue {
    background-color: #4AA1F3;
  }
  .text-blue {
    color: #4AA1F3;
  }
</style>
<body>
  <div class="wrapper">
      <!-- Nav -->
      <nav class="navbar navbar-expand navbar-white navbar-light ">
          <div class="container ">
            <!-- Left navbar links -->
            <ul class="navbar-nav ">
              <li class="nav-item">
                <h4 class="text-blue">Weather App</h4>
              </li>
            </ul>
      
            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto d-flex align-items-center">
              <li class="nav-item">
                <a class="nav-link text-blue" href="current.html">Current</a>
              </li>
              <li class="nav-item ml-4">
                <a class="nav-link text-blue" href="#">Forecast</a>
              </li>
            </ul>
          </div> 
      </nav> <!-- /nav -->

      <!-- Banner -->
      <div class="container-fluid bg-blue text-center text-white p-5">
          <h3 class="mt-2"><b>Get Weather Forecast</b></h3>
      </div><!-- /Banner -->

      <!-- Content -->
      <div class="container p-4">
          <h4 class="text-blue text-center mb-3">Enter City Name</h4>
          <div class="row">
            <div class="col-6 input-group mb-3 mx-auto">
              <input type="text" class="form-control" placeholder="Enter city name" id="inp-city-name">
              <input type="number" min="1" max="16" class="form-control ml-3" placeholder="NextDay: [1-16]" id="inp-days">
              <button class="btn btn-primary ml-3" type="button" id="btn-search-city">Search City</button>
            </div>
          </div>
      </div>

      <div class="container-fluid p-4 mb-5" id="forecast-display">
        <h4 class="text-center"><b>Weather forecast for <span id="span-city-name">PLACEHOLDER</span></b></h4>
        <table class="table table-bordered table-hover mx-auto">
          <thead class="bg-blue text-white">
              <tr>
                <th>Next Day</th>
                <th>Icon</th>
                <th>Weather</th>
                <th>Description</th>
                <th>Morning Temperature</th>
                <th>Night Temperature</th>
                <th>Min. Temperature</th>
                <th>Max. Temperature</th>
                <th>Pressure</th>
                <th>Humidity</th>
                <th>Wind Speed</th>
                <th>Wind Direction</th>
              </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
      <!-- Footer -->
      <footer class="fixed-bottom container-fluid bg-blue text-center p-2">
          <label class="mt-2 text-white">Copyright &copy; Weather App</label>
      </footer><!-- /Footer -->
  </div>
</body>
<script>
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
$(function() {
  $("#forecast-display").hide();
  $("#btn-search-city").click(onBtnSearchCityClick);
})
/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
function onBtnSearchCityClick() {
  // thu thập dữ liệu
  reqDataObj = {
    city: $("#inp-city-name").val().trim(),
    days: $("#inp-days").val()
  }
  console.log(reqDataObj);
  // kiểm tra
  let allIsGood = isDataValid(reqDataObj);
  if (allIsGood == false) {
    $(document).Toasts('create', {
        class: 'bg-warning',
        title: 'Chưa nhập đủ dữ liệu.',
        autohide: true,
        delay: 1200,
      })
  } else {
    ajaxGetForecast(reqDataObj);
  }


}
/*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
function ajaxGetForecast(paramReqDataObj) {
  $.ajax({
    url: 'http://api.openweathermap.org/data/2.5/forecast/daily?q=' + paramReqDataObj.city + "&units=metric" +
        "&cnt=" + paramReqDataObj.days + "&APPID=c10bb3bd22f90d636baa008b1529ee25",
    type: "GET",
    dataType: "json",
    success: function (data) {
      console.log(data);
      $("#span-city-name").text(data.city.name + ", " + data.city.country)
      $("#forecast-display").show();
      $("tbody").html("");
      for (var i = 0; i < data.list.length; i++) {
        var icon = "http://openweathermap.org/img/w/" + data.list[i].weather[0].icon + ".png";
        var weather = data.list[i].weather[0].main;
        var description = data.list[i].weather[0].description;
        var morning_temperature = data.list[i].temp.morn;
        var night_temperature = data.list[i].temp.night;
        var min_temperature = data.list[i].temp.min;
        var max_temperature = data.list[i].temp.max;
        var pressure = data.list[i].pressure;
        var humidity = data.list[i].humidity;
        var speed = data.list[i].speed;
        var deg = data.list[i].deg;

        let newRow = $("<tr>").appendTo($("tbody")[0]);
          // next day
        $("<td>").appendTo(newRow).text(i+1)
          // icon
        $("<td>").appendTo(newRow).append(
          $("<img>",{ src:icon})
        )
          // weather
        $("<td>").appendTo(newRow).text(weather)
          // description
        $("<td>").appendTo(newRow).text(description)
          // morning_temperature
        $("<td>").appendTo(newRow).text(morning_temperature + "°C")
          // night_temperature
        $("<td>").appendTo(newRow).text(night_temperature + "°C")
          // min_temperature
        $("<td>").appendTo(newRow).text(min_temperature + "°C")
          // max_temperature
        $("<td>").appendTo(newRow).text(max_temperature + "°C")
          // pressure
        $("<td>").appendTo(newRow).text(pressure + "hpa")
          // humidity
        $("<td>").appendTo(newRow).text(humidity + "%")
          // speed
        $("<td>").appendTo(newRow).text(speed + "m/s")
          // deg
        $("<td>").appendTo(newRow).text(deg+ "°")
      }
    }
  });
}
function isDataValid(paramReqDataObj) {
  if (paramReqDataObj.city == "" || paramReqDataObj.days == ""){
    return false;
  }
  return true;
}
</script>
</html>